/*$T PrePareNETCF.cpp GC 1.138 09/16/05 10:07:08 */

/* setup5.dll according to 751G users manual page 86 */
#include <windows.h>

#include <Tlhelp32.h>
#pragma comment (lib, "toolhelp.lib")
#include <winioctl.h>
#include "ce_setup.h"   /* in the public SDK dir */
#define IOCTL_TERMINAL_RESET    CTL_CODE( FILE_DEVICE_UNKNOWN, FILE_ANY_ACCESS, 2050, METHOD_NEITHER )

/*
 =======================================================================================================================
 * Purpose create dummy file, ie create a file on top of a ROM file to be able to replace it without err msg!
 * in:  full filename
 * out: 0 for success, -1 for error
 =======================================================================================================================
 */
int createDummyFile(TCHAR * file)
{
	HANDLE hFile;
	int res=0;
	TCHAR buf[64]=L"Dummy File!\n";
	DWORD dwRes=0;
	//create a new file
	hFile = CreateFile(file, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0);
	if (hFile == INVALID_HANDLE_VALUE)
	{
		OutputDebugString(L"Error creating file");
		return -1;
	}
	else
	{
		res = WriteFile(hFile, buf, wcslen(buf)*2, &dwRes, NULL);
		if (res == 0)
		{
			//error
			CloseHandle(hFile);
			return -2;
		}
		else
		{
			CloseHandle(hFile);
			return 0;
		}
	}
}

/*
 =======================================================================================================================
 *
 =======================================================================================================================
 */
BOOL APIENTRY DllMain( HANDLE h, DWORD reason, LPVOID lpReserved )
{
    return TRUE;
}   /* DllMain */

/*$DOCBEGIN$
 =======================================================================================================================
 *    
 *    BOOL IsProcessRunning( TCHAR * pname ); 
 *    * Description: Get process table snapshot, look for pname running. 
 *    * Arguments: pname - pointer to name of program to look for. 
 *    for example, app.exe. 
 *    * Returns: TRUE - process is running. 
 *    FALSE - process is not running. 
 *    $DOCEND$ 
 *
 =======================================================================================================================
 */

BOOL IsProcessRunning( TCHAR *pname )
{
    HANDLE          hProcList;
    PROCESSENTRY32  peProcess;
    DWORD           thDeviceProcessID;
    TCHAR           lpname[MAX_PATH];
    if ( !pname || !*pname )
    {
        return FALSE;
    }

    _tcscpy( lpname, pname );
    _tcslwr( lpname );
    hProcList = CreateToolhelp32Snapshot( TH32CS_SNAPPROCESS, 0 );
    if ( hProcList == INVALID_HANDLE_VALUE )
    {
        return FALSE;
    }       /* end if */

    memset( &peProcess, 0, sizeof(peProcess) );
    peProcess.dwSize = sizeof( peProcess );
    if ( !Process32First( hProcList, &peProcess ) )
    {
        CloseToolhelp32Snapshot( hProcList );
        return FALSE;
    }       /* end if */

    thDeviceProcessID = 0;
    do
    {
        _tcslwr( peProcess.szExeFile );
        if ( _tcsstr( peProcess.szExeFile, lpname ) )
        {
            thDeviceProcessID = peProcess.th32ProcessID;
            break;
        }   /* end if */
    }
    while ( Process32Next( hProcList, &peProcess ) );
    if ( (GetLastError() == ERROR_NO_MORE_FILES) && (thDeviceProcessID == 0) )
    {
        CloseToolhelp32Snapshot( hProcList );
        return FALSE;
    }       /* end if */

    CloseToolhelp32Snapshot( hProcList );
    return TRUE;
}           /* IsProcessRunning */

void ITC_reboot(void)
{
    HANDLE  h;
    if ( IsProcessRunning( L"autocab.exe" ) )
    {
        h = CreateFile
            (
                L"\\Windows\\__resetmeplease__.txt",
                (GENERIC_READ | GENERIC_WRITE),
                0,
                NULL,
                CREATE_ALWAYS,
                FILE_ATTRIBUTE_HIDDEN,
                NULL
            );
        if ( h != INVALID_HANDLE_VALUE )
        {
            CloseHandle( h );
        }
        else
        {
            /* Couldnt create the file. If it failed because the file already exists, it is not fatal.*/
            /* Otherwise, notify user of the inability to reset the device and they will have to*/
            /* perform it manually after all of the installations are complete. */
        }   /* end if */
    }
    else
    {
        DWORD   dret;
        h = CreateFile
            (
                L"SYI1 : ",
                (GENERIC_WRITE | GENERIC_READ),
                0,
                NULL,
                OPEN_EXISTING,
                FILE_ATTRIBUTE_NORMAL,
                NULL
            );

        /* Force a warm start NOW. */
        if ( h != INVALID_HANDLE_VALUE )
        {
            DeviceIoControl( h, IOCTL_TERMINAL_RESET, NULL, 0, NULL, 0, &dret, NULL );

            /* Wont return, but well show clean up anyway */
            CloseHandle( h );
        }
        else
        {
            /* Couldnt access SYSIO. Notify user. */
        }   /* end if */
    }       /* end if */

}
/*
 =======================================================================================================================
 *
 =======================================================================================================================
 */
codeINSTALL_INIT Install_Init( HWND hwndParent, BOOL fFirstCall, BOOL fPreviouslyInstalled, LPCTSTR pszInstallDir )
{
    return codeINSTALL_INIT_CONTINUE;
}

/*
 =======================================================================================================================
 *
 =======================================================================================================================
 */
codeINSTALL_EXIT Install_Exit
(
    HWND    hwndParent,
    LPCTSTR pszInstallDir,
    WORD    cFailedDirs,
    WORD    cFailedFiles,
    WORD    cFailedRegKeys,
    WORD    cFailedRegVals,
    WORD    cFailedShortcuts
)
{
    /*
	if ( cFailedDirs || cFailedFiles || cFailedRegKeys || cFailedRegVals || cFailedShortcuts )
    {
        return codeINSTALL_EXIT_UNINSTALL;
    }
	*/
	//Delete some files to avoid warnings when installing a CF service pack
	TCHAR *FileList[4]={ L"\\Windows\\mscoree.dll", L"\\Windows\\mscoree1_0.dll", L"\\Windows\\cgacutil.exe", L"\\Windows\\netcfagl1_0.dll" };
	for (int i=0; i<4; i++)
	{
		createDummyFile(FileList[i]);
	}
    return codeINSTALL_EXIT_DONE;
}

/*
 =======================================================================================================================
 *
 =======================================================================================================================
 */
codeUNINSTALL_INIT Uninstall_Init( HWND hwndParent, LPCTSTR pszInstallDir )
{
    /* TODO: Perform the reverse of INSTALL_INIT here */
    return codeUNINSTALL_INIT_CONTINUE;
}

/*
 =======================================================================================================================
 *
 =======================================================================================================================
 */
codeUNINSTALL_EXIT Uninstall_Exit( HWND hwndParent )
{
    /* TODO: Perform the reverse of INSTALL_EXIT here */
    return codeUNINSTALL_EXIT_DONE;
}
